<template>
  <div class="card">
    <h1>Add Employee</h1>
    <div class="flex-auto custom-form">
      <label for="name" class="font-bold block mb-3">Name</label>
      <InputText v-model="employee.name" inputId="name" placeholder="Adrian" />
    </div>
    <div class="flex-auto custom-form">
      <label for="surname" class="font-bold block mb-2">Surname</label>
      <InputText v-model="employee.surname" inputId="surname" placeholder="Lewis" />
    </div>
    <div class="flex-auto custom-form">
      <label for="address" class="font-bold block mb-2">Address</label>
      <InputText v-model="employee.address" inputId="address" placeholder="Marcus Street 11" />
    </div>
    <div class="flex-auto custom-form">
      <label for="date" class="font-bold block mb-2">Date of employment</label>
      <Calendar v-model="employee.employmentDate" inputId="date" />
    </div>
    <div class="flex-auto custom-form right-auto">
      <Button label="Add" icon="pi pi-plus" @click="add" />
      <InlineMessage v-if="!isFormValid">Fill out all fields</InlineMessage>
    </div>
  </div>
</template>

<script setup lang="ts">
import { type Ref, ref } from 'vue';
import InputText from 'primevue/inputtext';
import Calendar from 'primevue/calendar';
import Button from 'primevue/button';
import InlineMessage from 'primevue/inlinemessage';
import {useEmployeesStore} from "../../stores/employees/employees";
import type { Employee } from "../../stores/employees/employee";

const employeeStore: any = useEmployeesStore();

const employee: Ref<Employee> = ref({
  name: '',
  surname: '',
  address: '',
  employmentDate: '1/1/2023',
});

let isFormValid: Ref<boolean> = ref(true);

function add(): void {
  isFormValid.value = !(
    !employee.value.name ||
    !employee.value.surname ||
    !employee.value.address ||
    !employee.value.employmentDate
  );

  if (isFormValid.value) {
    employeeStore.addEmployee(employee.value);
  }
}
</script>

<style scoped>
.custom-form {
  margin-top: 10px;
  width: 40%;
}
</style>
